package oe.barbero.kata.conwaysgameoflife.cli

import org.assertj.core.api.Assertions
import org.junit.jupiter.api.Test

class CliSimulatorTests {
    @Test
    fun pattern1() {
        val cli = CliSimulator.fromPattern(
            """
            ......
            ..#...
            ..###.
            ......
            ......
        """.trimIndent()
        )

        Assertions.assertThat(cli.generate()).isEqualTo(
            """
            ......
            ..#...
            ..##..
            ...#..
            ......
        """.trimIndent()
        )
        Assertions.assertThat(cli.generate()).isEqualTo(
            """
            ......
            ..##..
            ..##..
            ..##..
            ......
        """.trimIndent()
        )
        Assertions.assertThat(cli.generate()).isEqualTo(
            """
            ......
            ..##..
            .#..#.
            ..##..
            ......
        """.trimIndent()
        )
    }

    @Test
    fun pattern2() {
        val cli = CliSimulator.fromPattern(
            """
            .........
            .........
            .........
            ....#....
            ...###...
            .........
            .........
            .........
            .........
        """.trimIndent()
        )

        Assertions.assertThat(cli.generate()).isEqualTo(
            """
            .........
            .........
            .........
            ...###...
            ...###...
            ....#....
            .........
            .........
            .........
        """.trimIndent()
        )
        Assertions.assertThat(cli.generate()).isEqualTo(
            """
            .........
            .........
            ....#....
            ...#.#...
            .........
            ...###...
            .........
            .........
            .........
        """.trimIndent()
        )
        Assertions.assertThat(cli.generate()).isEqualTo(
            """
            .........
            .........
            ....#....
            ....#....
            ...#.#...
            ....#....
            ....#....
            .........
            .........
        """.trimIndent()
        )
        Assertions.assertThat(cli.generate()).isEqualTo(
            """
            .........
            .........
            .........
            ...###...
            ...#.#...
            ...###...
            .........
            .........
            .........
        """.trimIndent()
        )
    }
}